from models.interfaces.ModelManager import ModelManager
from data.management.manager import Manager
from data.compression.zstd import Zstd
from data.transmission.resquests_wrapper import RequestWrapper
import pickle


class SkLearnModelManager(ModelManager):
    def __init__(self, manager: Manager = Manager(compression=Zstd(), transmission=RequestWrapper('http://localhost:8000/'))):
        super(SkLearnModelManager, self).__init__(manager=manager)

    def save_model(self, model, path):
        data = pickle.dumps(model)
        path = self.manager.save_object_to_path(data, path)
        return path

    def load_model(self, model_path):
        data = self.manager.load_file_from_path(model_path)
        return pickle.load(data)
